using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using  Syncfusion.Windows.Forms.Grid;

namespace GDBG_FilterBar_Dates
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(32, 32);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(512, 408);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(576, 470);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));
			dt.Columns.Add(new DataColumn("Date", typeof(DateTime)));

			DateTime date = new DateTime();
			Random r = new Random();
			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = string.Format("row{0} col{1}", i, j);
				  dr[nCols] = date = DateTime.Now.AddDays(r.Next(20));
				dt.Rows.Add(dr);
			}
			 dt.Rows.Add(new Object[] {"row9 col0","row9 col1","row9 col2","row9 col3",date});
			dt.Rows.Add(new Object[] {"row11 col0","row11 col1","row11 col2","row11 col3",date.AddMinutes(25)});
			dt.Rows.Add(new Object[] {"row12 col0","row12 col1","row12 col2","row12 col3",date.AddMinutes(50)});


			this.gridDataBoundGrid1.DataSource = dt;

			this.gridDataBoundGrid1.Binder.InternalColumns["Date"].StyleInfo.Format = "t"; //short date format

			MyGridFilterBar bar = new MyGridFilterBar();
			bar.WireGrid(this.gridDataBoundGrid1);


		}


	}

	public class MyGridFilterBar : GridFilterBar
	{
		int _none_ = 0;
		int _custom_ = 1;
		
		private GridDataBoundGrid grid1;
		public override void WireGrid(GridDataBoundGrid grid, GridStyleInfo style)
		{
			this.grid1 = grid;
			base.WireGrid (grid, style);
		}

		protected override string GetFilterFromRow(GridDataBoundGrid grid)
		{
			GridCurrentCell cc = grid.CurrentCell;
		
			int col = cc.ColIndex;
			string s = cc.Renderer.ControlText;
			
			GridStyleInfo style = grid.Binder.InternalColumns[grid.Binder.ColIndexToField(col)].StyleInfo;
			if(style.CellValueType != typeof(DateTime) || s == GridFilterBarStrings[_none_] || s == GridFilterBarStrings[_custom_])
			{
				return base.GetFilterFromRow(grid);
			}

			int row = this.GetFilterRow();
			DataTable dt = this.GetDataTable();
			string colName;
			string rowFilter = "";

			

			if(cc.IsActive)
				cc.Deactivate(false);
			DateTime d = DateTime.Parse(s);
			s = d.ToString();
			string s1 = d.AddMinutes(1).ToString();
			if (style.Format.Equals("d"))
			{
				s1 = d.AddDays(1).ToString();
			}
			 
			string gridColName = grid.Binder.InternalColumns[grid.Binder.ColIndexToField(col)].MappingName;
			colName = dt.Columns[gridColName].ColumnName;
			grid[row, col].Text = s;
			if (s.IndexOf("'") != -1)
				s = s.Replace("'", "''");
			grid[row, col].Tag = string.Format("[{0}] >= #{1}# AND [{0}] < #{2}#", colName, s, s1);				 
			
			
			//Otherwise form the filter string from the filter row values.
			for(int j = 1; j <= grid.Model.ColCount; ++j)
			{
				s = grid[row, j].Tag as string;
				if(s != null && s.Length > 0)
				{
					if(rowFilter.Length > 0)
						rowFilter += " and ";
					rowFilter += (string) s;
				}
			}
			return rowFilter;
		}

		protected override DataTable CreateUniqueEntries(DataView dv, string colName)
		{
			
			GridStyleInfo style = grid1.Binder.InternalColumns[grid1.Binder.NameToColIndex(colName)-1].StyleInfo;
			
			if(style.CellValueType != typeof(DateTime))
				return base.CreateUniqueEntries(dv, colName);

			DataTable dt = new DataTable(colName);
			dt.Columns.Add(new DataColumn(colName));

			DataRow dr;
			if(GridFilterBarStrings[_none_].Length > 0)
			{
				dr = dt.NewRow();
				dr[0] = GridFilterBarStrings[_none_];
				dt.Rows.Add(dr);
			}

//			if(GridFilterBarStrings[_custom_].Length > 0)
//			{
//				dr = dt.NewRow();
//				dr[0] = GridFilterBarStrings[_custom_];
//				dt.Rows.Add(dr);
//			}

			string s = "";
			for(int i = 0; i < dv.Count; ++i)
			{
				DateTime d = DateTime.Parse(dv[i].Row[colName].ToString());
				string s1 = d.ToString(style.Format);

				if(s != s1)
				{
					s = s1;
					dr = dt.NewRow();
					dr[0] = s;
					dt.Rows.Add(dr);
				}
			}
			return dt;
		}
	}
}
